#ifndef __MSG_FUNCS_H__
#define __MSG_FUNCS_H__
/*
 *   $RCSfile: msg_funcs.h,v $  
 *   $Revision: 2.18 $  
 *   $Date: 1993/04/13 17:45:13 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "ess.h"
#include "serverinfo.h"
#include "msgdefs.h"
#include "link.h"
#include "bitvec.h"

BEGIN_EXTERNC

extern int		initServerInfo();
extern void		shutServerInfo();
extern int		initMask();
extern int		initializeLinks();
extern void		links_Shutdown();
extern SERVERINFO 	*getServerInfo( char *, char *);
extern int		callServer (SERVERINFO *, MESSAGE *, char *, int);
extern int 		callServerMulti(SERVERINFO	*, IOVECENT *, int);
extern int  	connectServer (SERVERINFO *);
extern int		receive (SERVERINFO *, char *, int);
extern int		msg_Receive (SERVERINFO *, MESSAGE *, int);
extern BOOL		detectedDisconnect (SERVERINFO *);
extern SERVERINFO *findServerInfo(VOLID);
extern int		server_beginTrans(SERVERINFO *, TID *);
extern int		connectInit (char *, char *, BOOL);
extern int		server_connectInit (SERVERINFO *, BOOL);
extern int		msg_initClient(SERVERINFO *, BOOL);
extern void		clearLink(LINK*);
extern void		setLink(int, SERVERINFO*);
extern int		selectReceive(BITVEC *);
extern int		setSelectBits(int);

extern void  	serverForEach (int, void *, 
#ifdef __cplusplus
		void *arg1=(void *)0, void *arg2=(void *)0, void *arg3=(void *)0,
		void *arg4=(void *)0, void *arg5=(void *)0, void *arg6=(void *)0
#else __cplusplus
		void *, void *, void *,
		void *, void *, void *
#endif __cplusplus
	);

#define OID2SERVERINFO(oid)\
	findServerInfo(oid->diskAddr.volid)

#define FID2SERVERINFO(fid)\
	findServerInfo(fid->pid.volid)

#define VOLID2SERVERINFO(volid)\
	findServerInfo(volid)

#define PPID2SERVERINFO(pid)\
	findServerInfo(pid->volid)


END_EXTERNC

#endif __MSG_FUNCS_H__
