#ifndef _RECOVER_INTFUNCS_H_
#define _RECOVER_INTFUNCS_H_
/*
 *   $RCSfile: recover_intfuncs.h,v $  
 *   $Revision: 2.12 $  
 *   $Date: 1992/11/27 16:53:36 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#ifdef __cplusplus
extern "C" {
#endif


extern void			recoverRecord (LOGRECORDHDR *, LSNOFFSET);
extern void			recoverCompensation (LOGRECORDHDR *, LSNOFFSET);
extern void			recoverCommit (LOGRECORDHDR *);
extern void			recoverAbort (LOGRECORDHDR *, LSNOFFSET);
extern void			analyzeCheckpoint (LOGRECORDHDR *, LSNOFFSET);
extern void			redoActive (TRANSREC *, LOGRECORDHDR *, LSNOFFSET);
extern void			restart (OPENLOG *);
extern void			recoverUndo (LSNOFFSET);
#ifdef vax
extern void			recoverUndoTrans (TRANSREC*);
#else
extern void			recoverUndoTrans (void);
#endif
extern LSNOFFSET	restartRedo (OPENLOG *, LSNOFFSET);
extern void			sortUndoList (LIST*, LSNOFFSET);
extern LSNOFFSET	processLogForward (OPENLOG *, LSNOFFSET, FLAGS);
extern void			redoRecord (LOGRECORDHDR *, LSNOFFSET);
extern void			redoUser (LOGRECORDHDR *, LSNOFFSET);
extern void			analyzeRecord (LOGRECORDHDR *, LSN*);
extern void			analyzeTrans (LOGRECORDHDR *, LSN*);
extern void			analyzeUser (LOGRECORDHDR *, LSNOFFSET);
extern void			analyzeAbort (LOGRECORDHDR *, LSNOFFSET);
extern void			analyzeCommit (LOGRECORDHDR *);
extern void			setupEndOfLog (LSNOFFSET, BOOL);
extern void			analyzeDirtyPages (LOGRECORDHDR *);
extern void			analyzeMountVolume (LOGRECORDHDR *);
extern void			analyzeDismountVolume (LOGRECORDHDR *);
extern int			mountRecoveryVolumes ();
extern int			dismountRecoveryVolumes ();
extern void			recoverPreparedTrans ();

#ifdef vax
extern void			recoverServerPreparedTrans (TRANSREC *);
#elif defined(mips) || defined(sparc) || defined(_AIX) || defined(hpux)
extern void			recoverServerPreparedTrans (void);
#else
error
#endif

extern void			analyzeServerPrepare (LOGRECORDHDR *);
extern void			analyzeCoordPrepare (LOGRECORDHDR *);
extern void			analyzeEnd (LOGRECORDHDR *);

#ifdef __cplusplus
}
#endif
#endif /* _RECOVER_INTFUNCS_H_ */
