#ifndef __TRANS_EXTFUNCS_H__
#define __TRANS_EXTFUNCS_H__
/*
 *   $RCSfile: trans_extfuncs.h,v $  
 *   $Revision: 2.16 $  
 *   $Date: 1993/02/11 19:47:30 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

extern TRANSREC			*findTransRec (TID);
extern TRANSREC			*registerTrans (TID, BOOL);
extern void				abortLink (LINK *);
extern void				abortTrans (TRANSREC *, int);
#ifdef vax
extern void         asyncAbort (TRANSREC*, int);
#elif defined(mips) || defined(sparc) || defined(_AIX) || defined(hpux)
extern void         asyncAbort (void);
#else
error
#endif
extern void				commitTrans (TRANSREC *);
extern void				freeTransRec (TRANSREC *);
extern void				initializeTrans (void);
extern TRANSREC			*internalBegin (void);
extern TRANSREC			*allocRecoveryTrans (void);
extern void				quiesceTrans (TRANSREC *, int);
extern void				internalAbort (TRANSREC *, int);
extern TRANSVOLREC		*findTransVolRec (TRANSREC *, VOLREC *);
extern int 				notifyTrans (TRANSREC *, LIST *, int);
extern void				clearDirtyPageTable (void);
extern DIRTYPAGEINFO	*findOldestDirtyPage ();
extern int				listDirtyTransPages (TRANSREC *, DIRTYPAGELOGINFO *);
extern int				logTransDeallocPages (TRANSREC *, LIST *);
extern int				deallocTransPages (TRANSREC *, LIST *);
extern int				transDeallocFilePages (TRANSREC *);
extern int				freeFileDeallocInfo (TRANSREC *);
extern int				freePageDeallocInfo (TRANSREC *);
extern int				trans_FlushDirtyPages (TRANSREC *);
extern void				initializeRecoveryDirtyPageTable();
extern DIRTYPAGEINFO	*insertDirtyPageTable (PID *);
extern void				removeDeallocedDirtyPages (TRANSREC *);
extern void				removeDirtyPagesForVolume (VOLID);
extern DIRTYPAGEINFO	*searchDirtyPageTable (PID *);

#ifdef __cplusplus
}
#endif
#endif __TRANS_EXTFUNCS_H__
