#ifndef __CLOG_EXTFUNCS_H__
#define __CLOG_EXTFUNCS_H__
/*
 *   $RCSfile: clog_extfuncs.h,v $  
 *   $Revision: 1.18 $  
 *   $Date: 1993/04/21 17:25:40 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/


#include "trans.h"
#include "forward.h"

BEGIN_EXTERNC

extern int		clog_ForceLog (SERVERINFO *, FORCEMARK);
extern int		clog_ForceAllLogs (TRANSREC *);
extern int		clog_Initialize();
extern void		clog_Shutdown();
extern int		clog_serverInitialize(SERVERINFO *);
extern int		clog_BeginTransaction();
extern int		clog_LogWriteObj(OPERATIONINFO*);
extern int		clog_LogWriteObjND(OPERATIONINFO*);
extern int		clog_LogCreateObj(OPERATIONINFO*);
extern int		clog_LogCreateObjND(OPERATIONINFO*);
extern int		clog_LogDestroyObj(OPERATIONINFO*);
extern int		clog_LogDestroyObjND(OPERATIONINFO*);
extern int		clog_LogForwardObj(OPERATIONINFO*);
extern int		clog_LogChangeSmSize(OID*,OBJHDR*,int,int);
extern int		clog_LogChangeSmProps(OID*, OBJHDR*, TWO, TWO);
extern int		clog_LogChangeSmTag(OID*, OBJHDR*, TWO, TWO);
extern int		clog_LogModifyObj(OPERATIONINFO*);
extern int		clog_LogModifyObjND(OPERATIONINFO*);
extern int		clog_WriteLogPage(SERVERINFO *, PAGEHASH*);
extern int		clog_BtreePageInit(PID*, TWO, TWO);
extern int		clog_BtreeModifyLink(PID*, SHORTPID, SHORTPID, 
												SHORTPID, SHORTPID);
extern int		clog_BtreeModifyVector0(PID*, SHORTPID, SHORTPID);
extern int 	clog_BtreePhysicDelete(PID* pid, TWO startSlot, TWO numSlot);
extern int 	clog_BtreePhysicInsert(PID* pid, TWO startSlot, TWO numSlot);
extern int		clog_BtreeLogicInsert(PID* pid, PID* rootPid, void* key, 
												int keyLen, OID* oid);
extern int		clog_BtreeLogicDelete(PID* pid, PID* rootPid, void* key, 
												int keyLen, OID* oid);

int clog_BtOvDelete(PID* pid, TWO startSlot, TWO numSlot);
int clog_BtOvInsert(PID* pid, TWO startSlot, TWO numSlot);
int clog_BtOvModifyLink(PID* pid, SHORTPID oldNext, SHORTPID newNext,
									SHORTPID oldPrev, SHORTPID newPrev);
int clog_BtOvPageInit(PID* pid);

/* functions for logging large object updates */
extern int		clog_LogConvertToLarge(OPERATIONINFO*);
extern int		clog_LogDecrementLgCount(PID);
extern int		clog_LogIncrementLgCount(PID);
extern int		clog_LogModifyLgPage(OPERATIONINFO*);
extern int		clog_LogModifyLgPageND(OPERATIONINFO*);
extern int		clog_LogWriteLgNodeHdr(OPERATIONINFO*);
extern int		clog_LogWriteLgPage(OPERATIONINFO*);
extern int		clog_LogWriteLgPageND(OPERATIONINFO*);
extern int		clog_LogChangeSlots(OPERATIONINFO*);
extern int		clog_LogConvertToSmall(OPERATIONINFO*);

/* functions for logging index creation */
extern int		clog_LogCreateIndex(PID*, PAGEHASH*);


END_EXTERNC
#endif __CLOG_EXTFUNCS_H__
