/*
 *   $RCSfile: cl_MonDump.c,v $  
 *   $Revision: 1.13 $  
 *   $Date: 1993/04/13 18:33:18 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "io.h"
#include "object.h"
#include "tid.h"
#include "lock.h"
#include "msgdefs.h"
#include "thread.h"
#include "thread_globals.h"
#include "semaphore.h"
#include "bitvec.h"
#include "latch.h"
#include "link.h"
#include "cl_funcs.h"
#include "msg_funcs.h"
#include "disk.h"
#include "bf.h"
#include "volume.h"
#include "pool.h"
#include "server_util_funcs.h"
#include "io_globals.h"
#include "io_extfuncs.h"

 void
cl_MonDump (
	register MESSAGE	*unused1,
	register LINK		*unused2
)
{
#ifdef PROFIL
	/* All this is under control of -DPROFIL so that
	 * one can make a version of the server that
	 * doesn't require the -p option (to get monstartup, etc
	 * linked in).
	 * The idea is that you compile with -p -DPROFIL or with
	 * neither.  
	 */
	
	TRACE(TR_IO, TR_LEVEL_1);

	if( MonDump(TRUE, NULL) != esmNOERROR ) {
		reply( esmFAILURE, Active->errno, 1, TRUE);
	}
#endif PROFIL

	reply(esmNOERROR, esmNOERROR, 1, TRUE);
}


 void
cl_DebugSetVar (
	register MESSAGE	*message,
	register LINK		*unused
)
{
	switch( message->body.admin.operation ) {

#ifdef DEBUG
	case  ADMIN_DEBUG_SET_VAR: 
		TRPRINT(TR_CL | TR_MSG | TR_DISTR, TR_LEVEL_1, ("DEBUG VAR %d := %d", 
			message->body.admin.variable, message->body.admin.value));

		if( DebugSetVar(message->body.admin.variable, message->body.admin.value) ==
			esmNOERROR) {
			reply(esmNOERROR, esmNOERROR, 1, TRUE);
		}
		break;
#endif DEBUG

	default:
		TRPRINT(TR_CL | TR_MSG | TR_DISTR, TR_LEVEL_1, ("UNKNOWN DEBUG OPERATION %d", 
			message->body.admin.operation));
		break;
	}
	reply(esmFAILURE, esmNOTIMPLEMENTED, 1, TRUE);
}

 void
cl_NoSuchCommand (
	register MESSAGE	*unused1,
	register LINK		*unused2
)
{
	SM_ERROR(TYPE_CRASH, esmNOTIMPLEMENTED);
}
