#ifdef MEDIA_RECOVERY
/*
 *   $RCSfile: MR_CopyLogVolHdr.c,v $  
 *   $Revision: 1.9 $  
 *   $Date: 1993/02/04 20:30:06 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/


#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "pool.h"
#include "tid.h"
#include "io.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "thread.h"
#include "latch.h"
#include "semaphore.h"
#include "link.h"
#include "lsn.h"
#include "bf.h"
#include "volume.h"
#include "openlog.h"
#include "io_extfuncs.h"
#include "log_globals.h"
#include "com_packet.h"
#include "mr_intfuncs.h"


 int
MR_CopyLogVolHdr (

	VOLHDR	*volHdr 
)
{

	VOLREC	*volRec;

	
	TRACE(TR_LOG, TR_LEVEL_1);

	volRec = io_FindVolRec(OpenLog.volid);

	if (volRec == NULL) {
		SM_ERROR(TYPE_FATAL, esmINTERNAL);
	}

	*volHdr = *(volRec->header);

	return(esmNOERROR);
}

#endif MEDIA_RECOVERY
