#ifndef _IO_EXTFUNCS_H_
#define _IO_EXTFUNCS_H_
/*
 *   $RCSfile: io_extfuncs.h,v $  
 *   $Revision: 2.33 $  
 *   $Date: 1993/04/21 17:25:51 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "trans.h"
#include "volume.h"
#include "forward.h"

BEGIN_EXTERNC

extern int		io_AllocPages (VOLID, PAGE2SIZE, int, PID *, PID [], int);
extern int		io_AllocSlottedPages (int, PID *, PID [], FID *, FLAGS, UNIQUE *,BUFGROUP *);
extern int		io_CheckBitmap (PID *, int);
extern void		io_ClearStat (void);
extern int		io_DeallocPages (PAGE2SIZE, int, const PID *, BOOL, PAGETYPE);
extern int		io_DeallocSlottedPages (PID *, struct _FileInfo *, BOOL);
extern VOLREC	*io_Mount (VOLID);
extern int		io_Dismount (VOLID);
extern void		io_Final (void);
extern void		serverDied (void *);
extern VOLREC	*io_FindVolId (VOLID);

#ifdef JUNK
extern int		io_StatVol (VOLSTAT *);
#endif JUNK

extern VOLREC	*io_GetFreeSlot (void);
extern int		io_GetRootEntry (VOLID, char *, char *, int *);
extern int		io_RemoveRootEntry (VOLID, char *);
extern int		io_GetUnique (PID *, UNIQUE *, int);
extern int		io_Init (void);
extern int		io_AddVolume (VOLID, char *, char *); 
extern int		io_ReadPage (const PID *, char *, LOCKMODE *, PAGEHASH *);
extern int		io_ReadPageWithNeighbor (const PID *, char *, LOCKMODE *, PAGEHASH *,
						FLAGS, FID *, PID *);
extern int		io_SetRootEntry (VOLID, char *, char *, int);
extern int		io_WritePage (PID *, char *, PAGEHASH *);
extern int		io_WriteLogPage (SERVERINFO *, char *, PAGE2SIZE);
extern void		io_Shutdown ();
extern int     	io_SyncTrans ( TRANSREC *, BOOL );

extern void 	ForEachVolume(int , void *, 
#ifdef __cplusplus
		void *arg1=(void *)0, void *arg2=(void *)0, void *arg3=(void *)0,
		void *arg4=(void *)0, void *arg5=(void *)0, void *arg6=(void *)0
#else __cplusplus
		void *, void *, void *,
		void *, void *, void *
#endif __cplusplus
	);

END_EXTERNC
#endif /* _IO_EXTFUNCS_H_ */
