#ifndef __SM_EXTFUNCS_H__
#define __SM_EXTFUNCS_H__
/*
 *   $RCSfile: sm_extfuncs.h,v $  
 *   $Revision: 2.73 $  
 *   $Date: 1993/08/20 13:44:47 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "serverinfo.h"
#include "distr.h"
#include "msgstats.h"

extern int BT_MAXKEYLEN;

/* BEGIN visible to user */

struct _ServerStats;

BEGIN_EXTERNC

extern int		sm_Enter2PC PROTO((TID, GTID, COORD_HANDLE * ));
extern int		sm_PrepareTransaction PROTO((TID, VOTE * ));
extern int		sm_Recover2PC PROTO((COORD_HANDLE, GTID, TID *, BOOL ));
extern int		sm_Continue2PC PROTO((TID, BOOL ));
extern int		sm_AbortTransaction PROTO((TID ));
extern int		sm_AppendToObject PROTO((int, OID *, int, void * ));
extern int		sm_BeginTransaction PROTO((TID * ));
extern int		sm_CloseBufferGroup PROTO((int ));
extern int		sm_BufferGroupInfo PROTO((int, int *, int *, int * ));
extern int		sm_CloseLoad PROTO((LOADDESC * ));
extern int		sm_CloseScan PROTO((SCANDESC * ));
extern int		sm_CommitTransaction PROTO((TID ));
extern int		sm_CreateFile PROTO((int, VOLID, FID *));
extern int		sm_DestroyFile PROTO((int, FID * ));
extern int      sm_SetLogLevel PROTO((int, int, FID[]));
extern int		sm_CreateObject PROTO((int, FID *, int, OID *, OBJHDR *, int, void *, OID * ));
extern int		sm_DeleteFromObject PROTO((int, OID *, int, int ));
extern int		sm_DestroyObject PROTO((int, OID * ));
extern char		*sm_Error PROTO((int ));
extern int		sm_GetFirstOid PROTO((int, FID *, OID *, OBJHDR *, BOOL * ));
extern int		sm_GetLastOid PROTO((int, FID *, OID *, OBJHDR *, BOOL * ));
extern int		sm_GetNextOid PROTO((int, OID *, OID *, OBJHDR *, BOOL * ));
extern int		sm_GetPreviousOid PROTO((int, OID *, OID *, OBJHDR *, BOOL * ));
extern int		sm_GetRootEntry PROTO((VOLID, char *, void *, int * ));
extern int		sm_Initialize PROTO((void));
extern int		sm_InsertInObject PROTO((int, OID *, int, int, void * ));
extern int		sm_LoadNextObject PROTO((LOADDESC *, int, void *, OID * ));
extern int		sm_OpenBufferGroup PROTO((int, int, int *, FLAGS ));
extern int		sm_OpenLoad PROTO((FID *, int, float, LOADDESC ** ));
extern int		sm_OpenScan PROTO((FID *, int, int, SCANDESC **, OID * ));
extern int		sm_OpenScanWithGroup PROTO((FID *, int, int, SCANDESC **, OID * ));
extern int		sm_ReadObject PROTO((int, OID *, int, int, USERDESC **));
extern int		sm_ReadObjectHeader PROTO((int, OID *, OBJHDR * ));
extern int		sm_ReleaseObject PROTO((USERDESC * ));
extern int		sm_ScanNextBytes PROTO((SCANDESC *, int ));
extern int		sm_ScanNextObject PROTO((SCANDESC *, int, int, USERDESC **, BOOL * ));
extern int		sm_SetObjectHeader PROTO((int, OID *, OBJHDR * ));
extern int		sm_SetRootEntry PROTO((VOLID, char *, void *, int ));
extern int		sm_RemoveRootEntry PROTO((VOLID, char *));
extern int		sm_ShutDown PROTO((void ));
extern int		sm_WriteObject PROTO((int, int, int, void *, USERDESC *, BOOL ));

extern int		sm_LockObject PROTO((int, OID *, LOCKMODE));
extern int		sm_OidToFid PROTO((int, OID *, FID *));
extern int		sm_FreezeVersion PROTO((int, OID * ));
extern int		sm_CreateVersion PROTO((int, int, OID *, OID*, OID* ));
extern char		*sm_ErrorId PROTO((int ));

/*
 *	Administrative functions
 */
extern int		sm_TakeCheckpoint PROTO((FLAGS, VOLID, TWO ));
extern int		sm_ChangeCheckpointFrequency PROTO((FLAGS, VOLID, int ));
extern int		sm_ShutdownServer PROTO((FLAGS, VOLID, FLAGS ));
extern int		sm_ServerStatistics PROTO((FLAGS, VOLID, int *, struct _ServerStats **, BOOL ));
extern int 		sm_PrintMessageStats PROTO((FILE *const, MESSAGESTATS *const));
extern int 		sm_PageCount PROTO((FID*, int*));
extern int 		sm_VolumeProperties PROTO((VOLID, int *));
extern int 		sm_AddServerVolume PROTO((FLAGS, VOLID, char *, char *));
extern int 		sm_RemoveServerVolume PROTO((FLAGS, VOLID, VOLID)); 

extern int sm_CreateIndex PROTO((VOLID volume, int groupIndex, SMTYPE ndxType,
                    SMDATATYPE dataType, int maxKeyLen, 
					int elSize, BOOL unique, IID* ndx));
extern int sm_DestroyIndex PROTO((IID* ndx, int groupIndex));
extern int sm_InsertEntry PROTO((IID* ndx, int groupIndex, KEY* key, void* elem));
extern int sm_RemoveEntry PROTO((IID* ndx, int groupIndex, KEY* key, void* elem));
extern int sm_FetchInit PROTO((IID* ndx, int groupIndex, KEY* bound1, SMCOND cond1,
                          KEY* bound2, SMCOND cond2, SMCURSOR* cursor));
extern int sm_FetchNext PROTO((SMCURSOR* cursor, KEY* retKey, 
						  void* retElem, BOOL* eof));
extern int 	sm_SetLHashLoadThreshold PROTO((IID*, int, float));

extern int sm_BeginIndexLoad PROTO((IID* ndx, int groupIndex, int workVolume, int runSize));
extern int sm_EndIndexLoad PROTO((IID* ndx));
extern int sm_AbortIndexLoad PROTO((IID* ndx));


/*
 *	Option processing functions
 */

extern int		sm_SetClientOption PROTO((const char*, const void*, SMDATATYPE));
extern int		sm_GetClientOption PROTO((char*, void*));
extern int		sm_ReadConfigFile PROTO((char*, char*, char**));
extern int		sm_ParseCommandLine PROTO((int *, char**, char**));

extern int		sm_MountVolume PROTO((VOLID)); 
extern int		sm_DismountVolume PROTO((VOLID )); 	/* needed */

END_EXTERNC

/* END visible to user */


/* BEGIN visible to staff */
BEGIN_EXTERNC

extern int      sm_SyncTransaction PROTO((TID ));
extern int		sm_ResetRusage PROTO((FLAGS, VOLID));
extern int		sm_GetRusage PROTO((FLAGS, VOLID, int *, struct rusage **));
extern int		sm_MonDump PROTO((FLAGS, VOLID));
extern int 		sm_DebugSetVar PROTO((FLAGS, VOLID, int, int));
extern int		sm_TurnOffLogging PROTO((FLAGS, VOLID, FLAGS));
extern int		sm_TestNullMessage PROTO((FLAGS, VOLID, int ));
extern int		sm_TestPageMessage PROTO((FLAGS, VOLID, int, int, BOOL));
extern int 		sm_FindIndexLoad PROTO((IID* ndx, int* idx));
extern int 		sm_IsIndexEmpty PROTO((IID* ndx, int groupIndex, BOOL* ret));

extern void 	sm_CheckIndex PROTO((IID* ndx, int groupIndex));
extern void 	sm_PrintIndex PROTO((IID* ndx, int groupIndex, PFK printFunc));

	extern void     sm_SetAbortIfError(void);
	extern void     sm_UnsetAbortIfError(void);

	extern void     sm_FlushBuffers(BOOL); /* TRUE->discard pages */
END_EXTERNC

/* END visible to staff */

BEGIN_EXTERNC
	extern void		sm_ReleaseAllUserDesc(void);
	extern int		sm_CloseAllLoadsAndScans ();
	extern void     sm_EndAllIndexLoads(TID );
END_EXTERNC

/* BEGIN visible to E interpreter */
BEGIN_EXTERNC
extern int		sm_WroteObject PROTO((int, int, int, void *, USERDESC *, BOOL ));
END_EXTERNC
/* END visible to E interpreter */

#endif __SM_EXTFUNCS_H__
