#ifndef __TRANS_FUNCS_H__
#define __TRANS_FUNCS_H__
/*
 *   $RCSfile: trans_funcs.h,v $  
 *   $Revision: 2.11 $  
 *   $Date: 1993/04/02 14:30:25 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

#include "trans.h"
#include "serverinfo.h"
#include "distr.h"


BEGIN_EXTERNC

extern TID		*getLocalTid();
extern int		beginTrans (SERVERINFO *, TID *);
extern int		commitTrans (TRANSREC *);
extern int		commandTrans (TRANSREC *, COMMAND);
extern int		prepareTrans (TRANSREC *, VOTE *, BOOL);
extern int		abortTrans (TRANSREC *);
extern int		enter2PC (SERVERINFO *, TID *, GTID *);
TRANSREC 		*findTransRec (TID *tid);
extern int		checkTransState (VOLID);
extern int		checkVolumeState (VOLID);
extern TID 		*getServerTid (SERVERINFO *, VOLID, TRANSREC 	*);
extern int		checkLocalTransState (void);
extern int		closeBufferGroups (void);
extern int		initTrans (void);
extern void		trans_Shutdown (void);
extern void		internalAbort (void);
extern SERVERTRANSREC *addTransServerInfo(TRANSREC *, SERVERINFO *);
extern void		endTransForAllServers(TRANSREC *, int);
extern void		removeServerTransInfo(TRANSREC *, void *);
extern int		continue2PC(TRANSREC *);
extern int		recover2PC(COORD_HANDLE *, SERVERINFO *);
extern void		serverAbortedTrans(SERVERINFO *, TID);

extern void		ForEachServerInTrans(TRANSREC *, int , void *, 
#ifdef __cplusplus
		void *arg1=(void *)0, void *arg2=(void *)0, void *arg3=(void *)0,
		void *arg4=(void *)0, void *arg5=(void *)0, void *arg6=(void *)0
#else __cplusplus
		void *, void *, void *,
		void *, void *, void *
#endif
	);

extern void		ForEachTrans( int, void *,
#ifdef __cplusplus
		void *arg1=(void *)0, void *arg2=(void *)0, void *arg3=(void *)0
#else __cplusplus
		void *, void *, void *
#endif
	);

END_EXTERNC
#endif __TRANS_FUNCS_H__
