/*
 *   $RCSfile: thread_funcs.h,v $  
 *   $Revision: 2.15 $  
 *   $Date: 1993/04/09 20:12:56 $      
 */ 
#ifndef  __THREAD_FUNCS_H__
#define  __THREAD_FUNCS_H__
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
#ifdef __cplusplus
extern "C" {
#endif

extern int		threadFork (int, PFI, int, FOUR *);	 /* forks and runs T_CHILD or T_PARENT */
extern void		threadRestart (void);				/* goes to beginning of  loop() */

extern void		reinitTcb (TCB *);
#ifdef vax 
extern void		initializeTcb (char*, TCB *, FOUR *, FOUR);
#else
extern void		initializeTcb (PFI, TCB *, FOUR *, FOUR);
#endif vax
extern void		freeThread (TCB *);	 /* scrubs thread, puts on free list, notifies waiting-to-fork */

extern void		initializeThreads (FOUR, PFI);
extern void		threadSwitch (TCB *);		/* switch to the given thread */
extern int		auditThread (TCB *, FOUR);  /* counts unused words on stack */
extern int		dispatch (int);	/* goto end of readyq in this state and 
									threadSwitch to next ready thread */
extern void		notify (LIST *, int, int); /* every thread on this list gets the given
										error and errno and gets put on the readyq. 
										does not switch threads. */
extern void 	WakeUp( TCB *);		/* puts thread on readyq */
extern void		Sleep( int );

#define			SLEEP_INDEFINITELY	-1	 /* no timeout */
#define			SLEEP_DONT_SLEEP	0	 /* put on the end of the ready list */

#ifdef __cplusplus
}
#endif
#endif  __THREAD_FUNCS_H__
