#ifndef _LOGDUMP_H_
#define _LOGDUMP_H_
/*
 *   $RCSfile: logdump.h,v $  
 *   $Revision: 1.10 $  
 *   $Date: 1992/11/27 16:55:11 $
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
/* Include files from EXODUS */

#ifdef SERVER_MAKE
#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "error.h"
#include "tid.h"
#include "io.h"
#include "page.h"
#include "lsn.h"
#include "trace.h"
#include "object.h"
#include "list.h"
#include "pool.h"
#include "lock.h"
#include "msgdefs.h"
#include "thread.h"
#include "semaphore.h"
#include "latch.h"
#include "link.h"
#include "bf.h"
#include "logrecs.h"
#include "volume.h"
#include "openlog.h"
#include "trans.h"
#include "logaction.h"
#include "log.h"
#include "bitmap.h"
#include "log_extfuncs.h"
#include "bf_extfuncs.h"
#include "io_extfuncs.h"
#include "recover_intfuncs.h"
#include "trans_extfuncs.h"
#include "analyze_extfuncs.h"
#include "thread_globals.h"

#else

#include "../include/mrerror.h"
#include "/usr/include/setjmp.h"
#include "include/ess.h"
#include "include/error.h"
#include "include/io.h"
#include "include/tid.h"
#include "include/page.h"
#include "include1/lsn.h"
#include "oj.h"
#include "include1/logrecs.h"
#include "include/sysdefs.h"
#include "include/checking.h"
#include "trace.h"
#include "include/list.h"
#include "include/pool.h"
#include "include/lock.h"
#include "include/msgdefs.h"
#include "include1/thread.h"
#include "include1/semaphore.h"
#include "include1/latch.h"
#include "include1/link.h"
#include "bf.h"
#include "include1/openlog.h"
#include "include1/volume.h"
#include "include1/trans.h"
#include "include1/logaction.h"
#include "include1/log.h"
#include "include1/bitmap.h"
#include "include1/log_extfuncs.h"
#include "include1/bf_extfuncs.h"
#include "include1/io_extfuncs.h"
#include "include1/recover_intfuncs.h"
#include "include1/trans_extfuncs.h"
#include "include1/analyze_extfuncs.h"
#include "include1/thread_globals.h"

#endif SERVER_MAKE

/* Constant declarations */

#define MAXRECOVER 20 /* maximum number of pages/volumes that can be
			 in media recovery mode at once */
#define MAXNAMESIZE 20 /* maximum length of dump filename */
#define LOGDUMP "logdump" /* the name of the file that will contain the 
							 historical dump for this server */
#define CONTROL_FILE "mr_cntrl1"
#define  FOUND			1
#define  NOTFOUND		0

/* Some type definitions */


typedef struct {
off_t current;/* offset in the file from where to begin retrieving log pages */
int next;   /* indicates whether the next page also has to be shippped back
				to the SM */
PID datapid; /* the PID of the page being recovered */
int busy;   /* indicates whether there is any valid data here currently */
			 /* needed because the log page retrievals need not be in order */	
} RECOVERINFO;

typedef struct {
int server;
VOLHDR header;
} LOGINFO;

/* and finally, the variables */
#endif /* _LOGDUMP_H_ */
