/*
 *   $RCSfile: threadSwitch.c,v $  
 *   $Revision: 2.15 $  
 *   $Date: 1993/04/09 20:18:03 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "tid.h"
#include "io.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "thread.h"
#include "threadstate.h"
#include "thread_funcs.h"
#include "thread_globals.h"
#include "ips_support.h"


 void
threadSwitch (
	register TCB	*tcb
)
{

	TRPRINT(TR_THREAD, TR_LEVEL_1, ("switching to thread:%d", tcb->id));

	/*
	 *	check the tcb magic number
	 */
	CHECK_TCB_MAGIC(tcb);

	ThreadSwitchCount++;

	/*
	 *	save the current thread stack
	 */
	if (setjmp(Active->currentBuf) == 0)	{

		TRPRINT(TR_THREAD, TR_LEVEL_2, ("call to setjmp thread:%d", Active->id));

#ifdef IPS_SUPPORT
		{
			static unsigned long IPSserial = 0;
			trace(33, IPSserial);
			IPSdispatchThread(tcb->ipsid);
			trace(32, IPSserial);
			IPSserial++;
		}
#endif IPS_SUPPORT

		SANITY; /* check stacks */

		/*
		 *	set the active thread
		 */
		Active = tcb;
		Active->state = THREAD_ACTIVE;

		/*
		 *	jump to the right place
		 */
		TRPRINT(TR_THREAD, TR_LEVEL_2, ("jumping to thread:%d", tcb->id));
#ifdef IPS_SUPPORT
		IPS_longjmp(tcb->currentBuf, -1);
#else
		longjmp(tcb->currentBuf, -1);
#endif IPS_SUPPORT

	} else {

		TRPRINT(TR_THREAD, TR_LEVEL_2, ("returned from longjmp thread:%d", Active->id));
	}
}
