/*
 *   $RCSfile: setupMissingUpdateInfo.c,v $  
 *   $Revision: 1.6 $  
 *   $Date: 1992/11/19 06:11:41 $      
 */ 
/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/
#include "log.h"
#ifndef INIT_LRC_IS_LSN

#include "sysdefs.h"
#include "ess.h"
#include "checking.h"
#include "trace.h"
#include "error.h"
#include "list.h"
#include "tid.h"
#include "io.h"
#include "lock.h"
#include "object.h"
#include "msgdefs.h"
#include "thread.h"
#include "latch.h"
#include "semaphore.h"
#include "link.h"
#include "lsn.h"
#include "pool.h"
#include "logrecs.h"
#include "bf.h"
#include "undo.h"
#include "undo_extfuncs.h"
#include "undo_globals.h"
#include "bf_globals.h"


 MISSINGUPDATEINFO *
setupMissingUpdateInfo ()

{
	
	MISSINGUPDATEINFO	*missingUpdateInfo;

	TRPRINT(TR_RECOVER, TR_LEVEL_1, (""));

	/*
	 *	Get a table from the free list
	 */
	if ((missingUpdateInfo = (MISSINGUPDATEINFO *) poolDeq( &MissingUpdateInfoPool )) == NULL) {

		SM_ERROR(TYPE_FATAL, esmINTERNAL);
	    return(NULL);
	}

	/*
 	 *	Validate the structure, add it to the in-use list, and return
	 */
	CHECK_MISSINGUPDATEINFO_MAGIC(missingUpdateInfo);
	listEnq(&UsedMissingUpdateTables, &(missingUpdateInfo->list));
	return missingUpdateInfo;
}
#endif INIT_LRC_IS_LSN
